VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.5#0"; "comctl32.Ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Harmonics test"
   ClientHeight    =   9990
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   13440
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9990
   ScaleWidth      =   13440
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picGraph 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      FillColor       =   &H00FFFFFF&
      FillStyle       =   0  'Solid
      Height          =   5175
      Left            =   7740
      ScaleHeight     =   5115
      ScaleWidth      =   5415
      TabIndex        =   6
      Top             =   300
      Width           =   5475
   End
   Begin VB.PictureBox picResultSpectrum 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   4095
      Left            =   120
      ScaleHeight     =   4035
      ScaleWidth      =   13095
      TabIndex        =   4
      Top             =   5760
      Width           =   13155
   End
   Begin VB.PictureBox picWaveform 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   4215
      Left            =   120
      ScaleHeight     =   4155
      ScaleWidth      =   7395
      TabIndex        =   2
      Top             =   1260
      Width           =   7455
   End
   Begin ComctlLib.Slider sldCutOff 
      Height          =   615
      Left            =   60
      TabIndex        =   0
      Top             =   360
      Width           =   7455
      _ExtentX        =   13150
      _ExtentY        =   1085
      _Version        =   327682
      Max             =   180
      TickFrequency   =   10
   End
   Begin VB.Label Label1 
      Caption         =   "Click on graph"
      Height          =   315
      Left            =   7740
      TabIndex        =   7
      Top             =   60
      Width           =   3135
   End
   Begin VB.Label Label3 
      Caption         =   "Result spectrum"
      Height          =   315
      Left            =   120
      TabIndex        =   5
      Top             =   5520
      Width           =   3855
   End
   Begin VB.Label Label2 
      Caption         =   "Waveform after cut-off"
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   1020
      Width           =   3855
   End
   Begin VB.Label lblCutOff 
      Caption         =   "Cut-off angle"
      Height          =   255
      Left            =   60
      TabIndex        =   1
      Top             =   120
      Width           =   4575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const PI        As Single = 3.1415926
Private Const FFT_SIZE  As Long = 1024
Private Const HARMONICS As Long = 5     ' // Number of harmonics
Private Const BASE_FREQ As Long = 10    ' // Base frequency (period)

#Const LINEAR = True

Private m_fSpectrum()   As Single
Private m_fMaxAmp       As Single
Private m_fCoef(1, 13)  As Single

Private Sub Form_Load()
    InitFFT
    Process
End Sub

Private Sub FFT( _
            ByRef fData() As Single, _
            ByVal IsInverse As Boolean)
    Dim i As Long, j As Long, n As Long, K As Long, io As Long, ie As Long, in_ As Long, nn As Long
    Dim ur As Single, ui As Single, tpr As Single, tpi As Single, tqr As Single, tqi As Single, _
        wr As Single, wi As Single, sr As Single, ti As Long, tr As Long, lLog As Long
    
    nn = FFT_SIZE \ 2: ie = FFT_SIZE
    lLog = Log(FFT_SIZE) / Log(2)
    
    For n = 1 To lLog
        wr = m_fCoef(0, lLog - n): wi = m_fCoef(1, lLog - n)
        If IsInverse Then wi = -wi
        in_ = ie \ 2: ur = 1: ui = 0
        For j = 0 To in_ - 1
            For i = j To FFT_SIZE - 1 Step ie
                io = i + in_
                tpr = fData(0, i) + fData(0, io): tpi = fData(1, i) + fData(1, io)
                tqr = fData(0, i) - fData(0, io): tqi = fData(1, i) - fData(1, io)
                fData(0, io) = tqr * ur - tqi * ui: fData(1, io) = tqi * ur + tqr * ui
                fData(0, i) = tpr: fData(1, i) = tpi
            Next
            sr = ur: ur = ur * wr - ui * wi: ui = ui * wr + sr * wi
        Next
        ie = ie \ 2
    Next

    j = 1
    For i = 1 To FFT_SIZE - 1
        If i < j Then
            io = i - 1: in_ = j - 1: tpr = fData(0, in_): tpi = fData(1, in_)
            fData(0, in_) = fData(0, io): fData(1, in_) = fData(1, io)
            fData(0, io) = tpr: fData(1, io) = tpi
        End If
        K = nn
        Do While K < j
            j = j - K: K = K \ 2
        Loop
        j = j + K
    Next
    
    If IsInverse Then Exit Sub

    wr = 1 / FFT_SIZE
    For i = 0 To FFT_SIZE - 1
        fData(0, i) = fData(0, i) * wr: fData(1, i) = fData(1, i) * wr
    Next

    
End Sub

Private Sub InitFFT()
    Dim n As Long, vRcoef As Variant, vIcoef As Variant
    
    vRcoef = Array(-1#, 0#, 0.707106781186547 _
          , 0.923879532511287, 0.98078528040323, 0.995184726672197 _
          , 0.998795456205172, 0.999698818696204, 0.999924701839145 _
          , 0.999981175282601, 0.999995293809576, 0.999998823451702 _
          , 0.999999705862882, 0.999999926465718)
    vIcoef = Array(0#, -1#, -0.707106781186547 _
         , -0.38268343236509, -0.195090322016128, -9.80171403295606E-02 _
         , -0.049067674327418, -2.45412285229122E-02, -1.22715382857199E-02 _
         , -6.1358846491544E-03, -3.0679567629659E-03, -1.5339801862847E-03 _
         , -7.669903187427E-04, -3.834951875714E-04)
         
    For n = 0 To 13
        m_fCoef(0, n) = vRcoef(n): m_fCoef(1, n) = vIcoef(n)
    Next
    
End Sub

Private Sub Process()
    Dim fSignal()   As Single
    Dim lIndex      As Long
    Dim fDelta      As Single
    Dim fPeriod     As Single
    Dim fPhase      As Single
    Dim fThreshold  As Single
    Dim fSample     As Single
    Dim fAngle      As Single
    
    ReDim fSignal(FFT_SIZE - 1)
    ReDim m_fSpectrum(1, FFT_SIZE - 1)
    
    fPeriod = BASE_FREQ
    fDelta = fPeriod / FFT_SIZE
    
    fThreshold = Cos(sldCutOff.Value / 180 * PI)
    
    For lIndex = 0 To FFT_SIZE - 1
        
        fPhase = fPhase + fDelta
        If fPhase > 2 Then fPhase = fPhase - 1

        fSample = Cos(fPhase * PI * 2)

        If fSample <= fThreshold Then
            fSignal(lIndex) = 0
        Else
            fSignal(lIndex) = (fSample - fThreshold) / 2
        End If

    Next
    
    DrawWaveForm picWaveform, fSignal
    
    fAngle = (FFT_SIZE / fPeriod) * (sldCutOff.Value / 360)
    
    picWaveform.Line (fAngle, 1)-Step(0, -2), &H8000&
    picWaveform.Print "Cut-off angle " & Format$(sldCutOff.Value / 180 * PI, "0.000");
    
    PutWaveformToComplex m_fSpectrum, fSignal
    
    FFT m_fSpectrum(), False
    
    ' // Update amp of real signal
    m_fSpectrum(0, 0) = m_fSpectrum(0, 0) / 2
    m_fSpectrum(1, 0) = m_fSpectrum(1, 0) / 2
    m_fSpectrum(0, FFT_SIZE \ 2) = m_fSpectrum(0, FFT_SIZE \ 2) / 2
    m_fSpectrum(1, FFT_SIZE \ 2) = m_fSpectrum(1, FFT_SIZE \ 2) / 2
    
    DrawSpectrum picResultSpectrum, m_fSpectrum
    
End Sub

Private Sub PutWaveformToComplex( _
            ByRef fComplex() As Single, _
            ByRef fWaveform() As Single)
    Dim i As Long
    
    For i = 0 To UBound(fWaveform)
        fComplex(0, i) = fWaveform(i)
        fComplex(1, i) = 0
    Next
    
End Sub

Private Sub DrawSpectrum( _
            ByVal cPic As PictureBox, _
            ByRef m_fSpectrum() As Single, _
            Optional ByRef sCaption As String)
    Dim fM()    As Single
    Dim i       As Long
    Dim fMax    As Single
    Dim col As Long
    Dim fPix As Single
    Dim fLast As Single
    Dim lSize   As Long
    
    lSize = UBound(m_fSpectrum, 2) \ 2 + 1
    
    ReDim fM(lSize - 1)

    For i = 0 To lSize - 1
        fM(i) = Sqr(m_fSpectrum(0, i) ^ 2 + m_fSpectrum(1, i) ^ 2)
    Next

    fMax = 1
    
    cPic.Scale (0, fMax * 1.1)-(lSize - 1, 0)
    cPic.Cls
    
    For i = 0 To lSize Step 16
        
        If i Mod 64 Then
            col = &HC0C0C0
        Else
            col = &H8080FF
        End If
        
        cPic.Line (i, cPic.ScaleTop)-Step(0, cPic.ScaleHeight), col
        
    Next

    fPix = fMax / 10
    
    For i = 0 To 10
        
        If i Mod 2 Then
            col = &HC0C0C0
        Else
            col = &HB0B0FF
        End If
        
        cPic.Line (0, i * fPix)-Step(lSize, 0), col
        
    Next
    
    cPic.DrawWidth = 1
    cPic.FillStyle = vbFSSolid
    cPic.FillColor = vbRed
    cPic.DrawMode = vbMaskPen
    
    Dim f1 As Single
    Dim f2 As Single
    
    For i = 1 To lSize - 1

        col = &HFF0000
        
        f1 = (fM(i - 1)):   f2 = (fM(i))
        
        f1 = (Log(f1 + 0.001) / Log(10) + 3) / 3
        f2 = (Log(f2 + 0.001) / Log(10) + 3) / 3
        
        cPic.Line (i - 1, f1)-(i, f2), col

    Next
    
    cPic.DrawMode = vbCopyPen
    cPic.DrawWidth = 1
    
    cPic.CurrentX = cPic.ScaleLeft
    cPic.CurrentY = cPic.ScaleTop
    cPic.Print sCaption
    
End Sub

Private Sub DrawWaveForm( _
            ByVal cPic As PictureBox, _
            ByRef fWaveform() As Single)
    Dim fMax    As Single
    Dim i As Long
    Dim col As Long
    Dim fPix As Single
    
    m_fMaxAmp = -9999999999#
    
    For i = 0 To FFT_SIZE - 1
    
        If Abs(fWaveform(i)) > m_fMaxAmp Then
            m_fMaxAmp = Abs(fWaveform(i))
        End If
        
    Next
    
    fMax = 1
    
    cPic.Scale (0, fMax * 1.1)-(FFT_SIZE - 1, -fMax * 1.1)
    cPic.Cls
    
    For i = 0 To FFT_SIZE Step 128
        
        If i Mod 2 Then
            col = &HC0C0C0
        Else
            col = &H8080FF
        End If
        
        cPic.Line (i, cPic.ScaleTop)-Step(0, cPic.ScaleHeight), col
        cPic.Line (-i, cPic.ScaleTop)-Step(0, cPic.ScaleHeight), col
        
    Next
    
    cPic.Line (FFT_SIZE / 2, cPic.ScaleTop)-Step(0, cPic.ScaleHeight), &H8080FF
    
    fPix = fMax / 5
    
    For i = 0 To 5
        
        If i Mod 5 Then
            col = &HC0C0C0
        Else
            col = &HB0B0FF
        End If
        
        cPic.Line (cPic.ScaleLeft, i * fPix)-Step(cPic.ScaleWidth, 0), col
        cPic.Line (cPic.ScaleLeft, -i * fPix)-Step(cPic.ScaleWidth, 0), col
        
    Next
    
    cPic.DrawWidth = 1
    cPic.FillStyle = vbFSSolid
    cPic.FillColor = vbRed
    
    Dim f1 As Single
    Dim f2 As Single
    
    For i = 0 To FFT_SIZE - 1
        
        col = &HFF0000
        
        If i Then
            f1 = fWaveform(i - 1)
            f2 = fWaveform(i)
        
            cPic.Line (i - 1, f1)-(i, f2), vbBlue
    
        End If
 
    Next
    
    cPic.DrawWidth = 1
    
End Sub

Private Sub picGraph_Click()
    Dim lAngle  As Long
    Dim lBin    As Long
    Dim lHarm   As Long
    Dim lIndex  As Long
    Dim fValue  As Single
    Dim fAcc()  As Single
    Dim lColor  As Long
    Dim f       As Single
    Dim fMax    As Single

    picGraph.Cls
    
    lBin = BASE_FREQ
    
    ReDim fAcc(HARMONICS)
    
#If LINEAR Then
    picGraph.Scale (0, 0.6)-(180, 0)
#Else
    picGraph.Scale (0, 1)-(180, 0)
#End If
    For lAngle = 0 To 180 Step 10
        If lAngle Mod 60 Then
            picGraph.Line (lAngle, 0)-Step(0, picGraph.ScaleTop), &HC0C0C0
        Else
            picGraph.Line (lAngle, 0)-Step(0, picGraph.ScaleTop), &HA0A0A0
            picGraph.Print lAngle
        End If
    Next
    
#If LINEAR Then
    For lIndex = 1 To 5
#Else
    For lIndex = 1 To 8
#End If

#If LINEAR Then
        f = lIndex / 10
        fValue = f
#Else
        f = 0.001 ^ (lIndex / 10)
        fValue = (Log(f + 0.01) / Log(10) + 2) / 2
#End If
        picGraph.Line (180, fValue)-Step(-180, 0), &HA0A0A0
        picGraph.Print Format$(f, "0.00")
        
    Next
    
    picGraph.DrawMode = vbCopyPen
    
    For lAngle = 0 To 180
        
        sldCutOff.Value = lAngle
        DoEvents
        
        For lHarm = 0 To HARMONICS
            
            Select Case lHarm
            Case 0: lColor = vbRed
            Case 1: lColor = vbBlue
            Case 2: lColor = vbGreen
            Case 3: lColor = vbMagenta
            Case 4: lColor = vbCyan
            Case 5: lColor = &H800080
            End Select
            
            
            lIndex = lBin * lHarm
            
            fValue = Sqr(m_fSpectrum(0, lIndex) ^ 2 + m_fSpectrum(1, lIndex) ^ 2) * 2
            
            If m_fMaxAmp <> 0 Then
                fValue = fValue / m_fMaxAmp
            End If
            
#If Not LINEAR Then
            fValue = (Log(fValue + 0.01) / Log(10) + 2) / 2
#End If

            If lAngle Then
                
                picGraph.Line (lAngle - 1, fAcc(lHarm))-(lAngle, fValue), lColor
                
            End If
            
            fAcc(lHarm) = fValue
            
        Next
        
    Next

End Sub

Private Sub sldCutOff_Change()
    Process
End Sub

Private Sub sldCutOff_Scroll()
    Process
End Sub
